_B='Error %d while instantiating SHA-3/512'
_A=False
from Crypto.Util.py3compat import bord
from Crypto.Util._raw_api import load_pycryptodome_raw_lib,VoidPointer,SmartPointer,create_string_buffer,get_raw_buffer,c_size_t,c_uint8_ptr
from Crypto.Hash.keccak import _raw_keccak_lib
class SHA3_512_Hash:
	digest_size=64;oid='2.16.840.1.101.3.4.2.10'
	def __init__(A,data,update_after_digest):
		A._update_after_digest=update_after_digest;A._digest_done=_A;B=VoidPointer();C=_raw_keccak_lib.keccak_init(B.address_of(),c_size_t(A.digest_size*2),6)
		if C:raise ValueError(_B%C)
		A._state=SmartPointer(B.get(),_raw_keccak_lib.keccak_destroy)
		if data:A.update(data)
	def update(A,data):
		if A._digest_done and not A._update_after_digest:raise TypeError("You can only call 'digest' or 'hexdigest' on this object")
		B=_raw_keccak_lib.keccak_absorb(A._state.get(),c_uint8_ptr(data),c_size_t(len(data)))
		if B:raise ValueError('Error %d while updating SHA-3/512'%B)
		return A
	def digest(A):
		A._digest_done=True;B=create_string_buffer(A.digest_size);C=_raw_keccak_lib.keccak_digest(A._state.get(),B,c_size_t(A.digest_size))
		if C:raise ValueError(_B%C)
		A._digest_value=get_raw_buffer(B);return A._digest_value
	def hexdigest(A):return ''.join(['%02x'%bord(B)for B in A.digest()])
	def new(A):return type(A)(None,A._update_after_digest)
def new(*C,**A):
	B=A.pop('data',None);D=A.pop('update_after_digest',_A)
	if len(C)==1:
		if B:raise ValueError('Initial data for hash specified twice')
		B=C[0]
	if A:raise TypeError('Unknown parameters: '+str(A))
	return SHA3_512_Hash(B,D)
digest_size=SHA3_512_Hash.digest_size