_B=True
_A=False
import os,stat
__all__=['commonprefix','exists','getatime','getctime','getmtime','getsize','isdir','isfile','samefile','sameopenfile','samestat']
def exists(path):
	try:os.stat(path)
	except (OSError,ValueError):return _A
	return _B
def isfile(path):
	try:A=os.stat(path)
	except (OSError,ValueError):return _A
	return stat.S_ISREG(A.st_mode)
def isdir(s):
	try:A=os.stat(s)
	except (OSError,ValueError):return _A
	return stat.S_ISDIR(A.st_mode)
def getsize(filename):return os.stat(filename).st_size
def getmtime(filename):return os.stat(filename).st_mtime
def getatime(filename):return os.stat(filename).st_atime
def getctime(filename):return os.stat(filename).st_ctime
def commonprefix(m):
	if not m:return''
	if not isinstance(m[0],(list,tuple)):m=tuple(map(os.fspath,m))
	A=min(m);C=max(m)
	for (B,D) in enumerate(A):
		if D!=C[B]:return A[:B]
	return A
def samestat(s1,s2):return s1.st_ino==s2.st_ino and s1.st_dev==s2.st_dev
def samefile(f1,f2):A=os.stat(f1);B=os.stat(f2);return samestat(A,B)
def sameopenfile(fp1,fp2):A=os.fstat(fp1);B=os.fstat(fp2);return samestat(A,B)
def _splitext(p,sep,altsep,extsep):
	E=extsep;D=altsep;A=p.rfind(sep)
	if D:F=p.rfind(D);A=max(A,F)
	B=p.rfind(E)
	if B>A:
		C=A+1
		while C<B:
			if p[C:C+1]!=E:return p[:B],p[B:]
			C+=1
	return p,p[:0]
def _check_arg_types(funcname,*D):
	E=None;B=C=_A
	for A in D:
		if isinstance(A,str):B=_B
		elif isinstance(A,bytes):C=_B
		else:raise TypeError(f"{funcname}() argument must be str, bytes, or os.PathLike object, not {A.__class__.__name__!r}") from E
	if B and C:raise TypeError("Can't mix strings and bytes in path components") from E