_O='sha512'
_N='sha384'
_M='sha256'
_L='sha224'
_K='sha1'
_J='md5'
_I=None
_H='shake_256'
_G='shake_128'
_F='sha3_512'
_E='sha3_384'
_D='sha3_256'
_C='sha3_224'
_B='blake2s'
_A='blake2b'
__doc__='hashlib module - A common interface to many hash functions.\n\nnew(name, data=b\'\', **kwargs) - returns a new hash object implementing the\n                                given hash function; initializing the hash\n                                using the given binary data.\n\nNamed constructor functions are also available, these are faster\nthan using new(name):\n\nmd5(), sha1(), sha224(), sha256(), sha384(), sha512(), blake2b(), blake2s(),\nsha3_224, sha3_256, sha3_384, sha3_512, shake_128, and shake_256.\n\nMore algorithms may be available on your platform but the above are guaranteed\nto exist.  See the algorithms_guaranteed and algorithms_available attributes\nto find out what algorithm names can be passed to new().\n\nNOTE: If you want the adler32 or crc32 hash functions they are available in\nthe zlib module.\n\nChoose your hash function wisely.  Some have known collision weaknesses.\nsha384 and sha512 will be slow on 32 bit platforms.\n\nHash objects have these methods:\n - update(data): Update the hash object with the bytes in data. Repeated calls\n                 are equivalent to a single call with the concatenation of all\n                 the arguments.\n - digest():     Return the digest of the bytes passed to the update() method\n                 so far as a bytes object.\n - hexdigest():  Like digest() except the digest is returned as a string\n                 of double length, containing only hexadecimal digits.\n - copy():       Return a copy (clone) of the hash object. This can be used to\n                 efficiently compute the digests of datas that share a common\n                 initial substring.\n\nFor example, to obtain the digest of the byte string \'Nobody inspects the\nspammish repetition\':\n\n    >>> import hashlib\n    >>> m = hashlib.md5()\n    >>> m.update(b"Nobody inspects")\n    >>> m.update(b" the spammish repetition")\n    >>> m.digest()\n    b\'\\xbbd\\x9c\\x83\\xdd\\x1e\\xa5\\xc9\\xd9\\xde\\xc9\\xa1\\x8d\\xf0\\xff\\xe9\'\n\nMore condensed:\n\n    >>> hashlib.sha224(b"Nobody inspects the spammish repetition").hexdigest()\n    \'a4337bc45a8fc544c03f52dc550cd6e1e87021bc896588bd79e901e2\'\n\n'
__always_supported=_J,_K,_L,_M,_N,_O,_A,_B,_C,_D,_E,_F,_G,_H
algorithms_guaranteed=set(__always_supported)
algorithms_available=set(__always_supported)
__all__=__always_supported+('new','algorithms_guaranteed','algorithms_available','pbkdf2_hmac')
__builtin_constructor_cache={}
__block_openssl_constructor={_C,_D,_E,_F,_G,_H,_A,_B}
def __get_builtin_constructor(name):
	F='SHA384';E='SHA512';D='SHA224';C='SHA256';B='MD5';A='SHA1';cache=__builtin_constructor_cache;constructor=cache.get(name)
	if constructor is not _I:return constructor
	try:
		if name in{A,_K}:import _sha1;cache[A]=cache[_K]=_sha1.sha1
		elif name in{B,_J}:import _md5;cache[B]=cache[_J]=_md5.md5
		elif name in{C,_M,D,_L}:import _sha256;cache[D]=cache[_L]=_sha256.sha224;cache[C]=cache[_M]=_sha256.sha256
		elif name in{E,_O,F,_N}:import _sha512;cache[F]=cache[_N]=_sha512.sha384;cache[E]=cache[_O]=_sha512.sha512
		elif name in{_A,_B}:import _blake2;cache[_A]=_blake2.blake2b;cache[_B]=_blake2.blake2s
		elif name in{_C,_D,_E,_F}:import _sha3;cache[_C]=_sha3.sha3_224;cache[_D]=_sha3.sha3_256;cache[_E]=_sha3.sha3_384;cache[_F]=_sha3.sha3_512
		elif name in{_G,_H}:import _sha3;cache[_G]=_sha3.shake_128;cache[_H]=_sha3.shake_256
	except ImportError:pass
	constructor=cache.get(name)
	if constructor is not _I:return constructor
	raise ValueError('unsupported hash type '+name)
def __get_openssl_constructor(name):
	if name in __block_openssl_constructor:return __get_builtin_constructor(name)
	try:f=getattr(_hashlib,'openssl_'+name);f();return f
	except (AttributeError,ValueError):return __get_builtin_constructor(name)
def __py_new(name,data=b'',**kwargs):return __get_builtin_constructor(name)(data,**kwargs)
def __hash_new(name,data=b'',**kwargs):
	if name in __block_openssl_constructor:return __get_builtin_constructor(name)(data,**kwargs)
	try:return _hashlib.new(name,data)
	except ValueError:return __get_builtin_constructor(name)(data)
try:import _hashlib;new=__hash_new;__get_hash=__get_openssl_constructor;algorithms_available=algorithms_available.union(_hashlib.openssl_md_meth_names)
except ImportError:new=__py_new;__get_hash=__get_builtin_constructor
try:from _hashlib import pbkdf2_hmac
except ImportError:
	_trans_5C=bytes((x^92 for x in range(256)));_trans_36=bytes((x^54 for x in range(256)))
	def pbkdf2_hmac(hash_name,password,salt,iterations,dklen=_I):
		A='big'
		if not isinstance(hash_name,str):raise TypeError(hash_name)
		if not isinstance(password,(bytes,bytearray)):password=bytes(memoryview(password))
		if not isinstance(salt,(bytes,bytearray)):salt=bytes(memoryview(salt))
		inner=new(hash_name);outer=new(hash_name);blocksize=getattr(inner,'block_size',64)
		if len(password)>blocksize:password=new(hash_name,password).digest()
		password=password+b'\x00'*(blocksize-len(password));inner.update(password.translate(_trans_36));outer.update(password.translate(_trans_5C))
		def prf(msg,inner=inner,outer=outer):icpy=inner.copy();ocpy=outer.copy();icpy.update(msg);ocpy.update(icpy.digest());return ocpy.digest()
		if iterations<1:raise ValueError(iterations)
		if dklen is _I:dklen=outer.digest_size
		if dklen<1:raise ValueError(dklen)
		dkey=b'';loop=1;from_bytes=int.from_bytes
		while len(dkey)<dklen:
			prev=prf(salt+loop.to_bytes(4,A));rkey=int.from_bytes(prev,A)
			for i in range(iterations-1):prev=prf(prev);rkey^=from_bytes(prev,A)
			loop+=1;dkey+=rkey.to_bytes(inner.digest_size,A)
		return dkey[:dklen]
try:from _hashlib import scrypt
except ImportError:pass
for __func_name in __always_supported:
	try:globals()[__func_name]=__get_hash(__func_name)
	except ValueError:import logging;logging.exception('code for hash %s was not found.',__func_name)
del __always_supported,__func_name,__get_hash
del __py_new,__hash_new,__get_openssl_constructor