_A=None
from abc import ABCMeta,abstractmethod
__all__=['Number','Complex','Real','Rational','Integral']
class Number(metaclass=ABCMeta):__slots__=();__hash__=_A
class Complex(Number):
	__slots__=()
	@abstractmethod
	def __complex__(self):0
	def __bool__(A):return A!=0
	@property
	@abstractmethod
	def real(self):raise NotImplementedError
	@property
	@abstractmethod
	def imag(self):raise NotImplementedError
	@abstractmethod
	def __add__(self,other):raise NotImplementedError
	@abstractmethod
	def __radd__(self,other):raise NotImplementedError
	@abstractmethod
	def __neg__(self):raise NotImplementedError
	@abstractmethod
	def __pos__(self):raise NotImplementedError
	def __sub__(A,other):return A+-other
	def __rsub__(A,other):return-A+other
	@abstractmethod
	def __mul__(self,other):raise NotImplementedError
	@abstractmethod
	def __rmul__(self,other):raise NotImplementedError
	@abstractmethod
	def __truediv__(self,other):raise NotImplementedError
	@abstractmethod
	def __rtruediv__(self,other):raise NotImplementedError
	@abstractmethod
	def __pow__(self,exponent):raise NotImplementedError
	@abstractmethod
	def __rpow__(self,base):raise NotImplementedError
	@abstractmethod
	def __abs__(self):raise NotImplementedError
	@abstractmethod
	def conjugate(self):raise NotImplementedError
	@abstractmethod
	def __eq__(self,other):raise NotImplementedError
Complex.register(complex)
class Real(Complex):
	__slots__=()
	@abstractmethod
	def __float__(self):raise NotImplementedError
	@abstractmethod
	def __trunc__(self):raise NotImplementedError
	@abstractmethod
	def __floor__(self):raise NotImplementedError
	@abstractmethod
	def __ceil__(self):raise NotImplementedError
	@abstractmethod
	def __round__(self,ndigits=_A):raise NotImplementedError
	def __divmod__(A,other):B=other;return A//B,A%B
	def __rdivmod__(A,other):B=other;return B//A,B%A
	@abstractmethod
	def __floordiv__(self,other):raise NotImplementedError
	@abstractmethod
	def __rfloordiv__(self,other):raise NotImplementedError
	@abstractmethod
	def __mod__(self,other):raise NotImplementedError
	@abstractmethod
	def __rmod__(self,other):raise NotImplementedError
	@abstractmethod
	def __lt__(self,other):raise NotImplementedError
	@abstractmethod
	def __le__(self,other):raise NotImplementedError
	def __complex__(A):return complex(float(A))
	@property
	def real(self):return+self
	@property
	def imag(self):return 0
	def conjugate(A):return+A
Real.register(float)
class Rational(Real):
	__slots__=()
	@property
	@abstractmethod
	def numerator(self):raise NotImplementedError
	@property
	@abstractmethod
	def denominator(self):raise NotImplementedError
	def __float__(A):return A.numerator/A.denominator
class Integral(Rational):
	__slots__=()
	@abstractmethod
	def __int__(self):raise NotImplementedError
	def __index__(A):return int(A)
	@abstractmethod
	def __pow__(self,exponent,modulus=_A):raise NotImplementedError
	@abstractmethod
	def __lshift__(self,other):raise NotImplementedError
	@abstractmethod
	def __rlshift__(self,other):raise NotImplementedError
	@abstractmethod
	def __rshift__(self,other):raise NotImplementedError
	@abstractmethod
	def __rrshift__(self,other):raise NotImplementedError
	@abstractmethod
	def __and__(self,other):raise NotImplementedError
	@abstractmethod
	def __rand__(self,other):raise NotImplementedError
	@abstractmethod
	def __xor__(self,other):raise NotImplementedError
	@abstractmethod
	def __rxor__(self,other):raise NotImplementedError
	@abstractmethod
	def __or__(self,other):raise NotImplementedError
	@abstractmethod
	def __ror__(self,other):raise NotImplementedError
	@abstractmethod
	def __invert__(self):raise NotImplementedError
	def __float__(A):return float(int(A))
	@property
	def numerator(self):return+self
	@property
	def denominator(self):return 1
Integral.register(int)