_F='multiple'
_E='active'
_D='Cancel'
_C='initialdir'
_B='*'
_A=None
from tkinter import *
from tkinter.dialog import Dialog
from tkinter import commondialog
import os,fnmatch
dialogstates={}
class FileDialog:
	title='File Selection Dialog'
	def __init__(self,master,title=_A):
		E='yview';D='<Double-ButtonRelease-1>';C='<ButtonRelease-1>';B='set';A='<Return>'
		if title is _A:title=self.title
		self.master=master;self.directory=_A;self.top=Toplevel(master);self.top.title(title);self.top.iconname(title);self.botframe=Frame(self.top);self.botframe.pack(side=BOTTOM,fill=X);self.selection=Entry(self.top);self.selection.pack(side=BOTTOM,fill=X);self.selection.bind(A,self.ok_event);self.filter=Entry(self.top);self.filter.pack(side=TOP,fill=X);self.filter.bind(A,self.filter_command);self.midframe=Frame(self.top);self.midframe.pack(expand=YES,fill=BOTH);self.filesbar=Scrollbar(self.midframe);self.filesbar.pack(side=RIGHT,fill=Y);self.files=Listbox(self.midframe,exportselection=0,yscrollcommand=(self.filesbar,B));self.files.pack(side=RIGHT,expand=YES,fill=BOTH);btags=self.files.bindtags();self.files.bindtags(btags[1:]+btags[:1]);self.files.bind(C,self.files_select_event);self.files.bind(D,self.files_double_event);self.filesbar.config(command=(self.files,E));self.dirsbar=Scrollbar(self.midframe);self.dirsbar.pack(side=LEFT,fill=Y);self.dirs=Listbox(self.midframe,exportselection=0,yscrollcommand=(self.dirsbar,B));self.dirs.pack(side=LEFT,expand=YES,fill=BOTH);self.dirsbar.config(command=(self.dirs,E));btags=self.dirs.bindtags();self.dirs.bindtags(btags[1:]+btags[:1]);self.dirs.bind(C,self.dirs_select_event);self.dirs.bind(D,self.dirs_double_event);self.ok_button=Button(self.botframe,text='OK',command=self.ok_command);self.ok_button.pack(side=LEFT);self.filter_button=Button(self.botframe,text='Filter',command=self.filter_command);self.filter_button.pack(side=LEFT,expand=YES);self.cancel_button=Button(self.botframe,text=_D,command=self.cancel_command);self.cancel_button.pack(side=RIGHT);self.top.protocol('WM_DELETE_WINDOW',self.cancel_command);self.top.bind('<Alt-w>',self.cancel_command);self.top.bind('<Alt-W>',self.cancel_command)
	def go(self,dir_or_file=os.curdir,pattern=_B,default='',key=_A):
		if key and key in dialogstates:self.directory,pattern=dialogstates[key]
		else:
			dir_or_file=os.path.expanduser(dir_or_file)
			if os.path.isdir(dir_or_file):self.directory=dir_or_file
			else:self.directory,default=os.path.split(dir_or_file)
		self.set_filter(self.directory,pattern);self.set_selection(default);self.filter_command();self.selection.focus_set();self.top.wait_visibility();self.top.grab_set();self.how=_A;self.master.mainloop()
		if key:
			directory,pattern=self.get_filter()
			if self.how:directory=os.path.dirname(self.how)
			dialogstates[key]=directory,pattern
		self.top.destroy();return self.how
	def quit(self,how=_A):self.how=how;self.master.quit()
	def dirs_double_event(self,event):self.filter_command()
	def dirs_select_event(self,event):dir,pat=self.get_filter();subdir=self.dirs.get(_E);dir=os.path.normpath(os.path.join(self.directory,subdir));self.set_filter(dir,pat)
	def files_double_event(self,event):self.ok_command()
	def files_select_event(self,event):file=self.files.get(_E);self.set_selection(file)
	def ok_event(self,event):self.ok_command()
	def ok_command(self):self.quit(self.get_selection())
	def filter_command(self,event=_A):
		dir,pat=self.get_filter()
		try:names=os.listdir(dir)
		except OSError:self.master.bell();return
		self.directory=dir;self.set_filter(dir,pat);names.sort();subdirs=[os.pardir];matchingfiles=[]
		for name in names:
			fullname=os.path.join(dir,name)
			if os.path.isdir(fullname):subdirs.append(name)
			elif fnmatch.fnmatch(name,pat):matchingfiles.append(name)
		self.dirs.delete(0,END)
		for name in subdirs:self.dirs.insert(END,name)
		self.files.delete(0,END)
		for name in matchingfiles:self.files.insert(END,name)
		head,tail=os.path.split(self.get_selection())
		if tail==os.curdir:tail=''
		self.set_selection(tail)
	def get_filter(self):
		filter=self.filter.get();filter=os.path.expanduser(filter)
		if filter[-1:]==os.sep or os.path.isdir(filter):filter=os.path.join(filter,_B)
		return os.path.split(filter)
	def get_selection(self):file=self.selection.get();file=os.path.expanduser(file);return file
	def cancel_command(self,event=_A):self.quit()
	def set_filter(self,dir,pat):
		if not os.path.isabs(dir):
			try:pwd=os.getcwd()
			except OSError:pwd=_A
			if pwd:dir=os.path.join(pwd,dir);dir=os.path.normpath(dir)
		self.filter.delete(0,END);self.filter.insert(END,os.path.join(dir or os.curdir,pat or _B))
	def set_selection(self,file):self.selection.delete(0,END);self.selection.insert(END,os.path.join(self.directory,file))
class LoadFileDialog(FileDialog):
	title='Load File Selection Dialog'
	def ok_command(self):
		file=self.get_selection()
		if not os.path.isfile(file):self.master.bell()
		else:self.quit(file)
class SaveFileDialog(FileDialog):
	title='Save File Selection Dialog'
	def ok_command(self):
		file=self.get_selection()
		if os.path.exists(file):
			if os.path.isdir(file):self.master.bell();return
			d=Dialog(self.top,title='Overwrite Existing File Question',text='Overwrite existing file %r?'%(file,),bitmap='questhead',default=1,strings=('Yes',_D))
			if d.num!=0:return
		else:
			head,tail=os.path.split(file)
			if not os.path.isdir(head):self.master.bell();return
		self.quit(file)
class _Dialog(commondialog.Dialog):
	def _fixoptions(self):
		A='filetypes'
		try:self.options[A]=tuple(self.options[A])
		except KeyError:pass
	def _fixresult(self,widget,result):
		if result:
			try:result=result.string
			except AttributeError:pass
			path,file=os.path.split(result);self.options[_C]=path;self.options['initialfile']=file
		self.filename=result;return result
class Open(_Dialog):
	command='tk_getOpenFile'
	def _fixresult(self,widget,result):
		if isinstance(result,tuple):
			result=tuple([getattr(r,'string',r)for r in result])
			if result:path,file=os.path.split(result[0]);self.options[_C]=path
			return result
		if not widget.tk.wantobjects()and _F in self.options:return self._fixresult(widget,widget.tk.splitlist(result))
		return _Dialog._fixresult(self,widget,result)
class SaveAs(_Dialog):command='tk_getSaveFile'
class Directory(commondialog.Dialog):
	command='tk_chooseDirectory'
	def _fixresult(self,widget,result):
		if result:
			try:result=result.string
			except AttributeError:pass
			self.options[_C]=result
		self.directory=result;return result
def askopenfilename(**options):return Open(**options).show()
def asksaveasfilename(**options):return SaveAs(**options).show()
def askopenfilenames(**options):options[_F]=1;return Open(**options).show()
def askopenfile(mode='r',**options):
	filename=Open(**options).show()
	if filename:return open(filename,mode)
	return _A
def askopenfiles(mode='r',**options):
	files=askopenfilenames(**options)
	if files:
		ofiles=[]
		for filename in files:ofiles.append(open(filename,mode))
		files=ofiles
	return files
def asksaveasfile(mode='w',**options):
	filename=SaveAs(**options).show()
	if filename:return open(filename,mode)
	return _A
def askdirectory(**options):return Directory(**options).show()
def test():
	A='test';root=Tk();root.withdraw();fd=LoadFileDialog(root);loadfile=fd.go(key=A);fd=SaveFileDialog(root);savefile=fd.go(key=A);print(loadfile,savefile);enc='utf-8';import sys
	try:import locale;locale.setlocale(locale.LC_ALL,'');enc=locale.nl_langinfo(locale.CODESET)
	except (ImportError,AttributeError):pass
	openfilename=askopenfilename(filetypes=[('all files',_B)])
	try:fp=open(openfilename,'r');fp.close()
	except:print('Could not open File: ');print(sys.exc_info()[1])
	print('open',openfilename.encode(enc));saveasfilename=asksaveasfilename();print('saveas',saveasfilename.encode(enc))
if __name__=='__main__':test()